%% Copyright (c) <2011>, <Deepak Garg, garg.deepak@gmail.com>
%% All rights reserved.
%%
%% Use in source and binary forms, with or without modification, are
%% permitted provided that the following conditions are met:
%%
%% - Code derived from this source code must retain the above copyright
%%   notice, this list of conditions and the following disclaimer.
%%
%% - Use or modification is not done for any commercial purpose or for
%%   monetary gain
%%
%% Redistribution without permission of original copyright holder is
%% prohibited.
%%
%% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
%% "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
%% LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
%% A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
%% HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
%% SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
%% LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
%% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
%% THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%% (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
%% OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

<POL> and
      (<POL/ACC> %% Negative norm for actions
	 all [a][u] (and 
		       (does a u)
                       (true))
	 (or
	    (violated_action a u)
	    (<POL/ACC/RESIDENT> %% Positive norm for residents
	       ex [i][k] (eq_action a (read k i))
	       (and 
		  (hasattr_ext i (rec k))
		  (inrole k resident u)
		  %% Negative norm for physiotherapy notes
		  (all [k1][d1][u1] (hasattr_ext i (rec/dynamic/medicalrecord/psycho k1 d1 u1))
		     (allows d1 a u))))

	    (<POL/ACC/PR> %% Positive norm for personal representatives of residents
	       ex [i][k] (eq_action a (read k i))
	       (ex [k'] (hasattr_ext i (rec k'))
		  (and 
		     (inrole k (pr k') u)
		     (ex [m] (allows m a u)
			(inrole m manager u))
		     (or
			(emergency k' u)
			(mentally-incapable k' u)))))

	    (<POL/ACC/DOCTOR> %% Positive norm for doctors
	       ex [i][k] (eq_action a (read k i))
	       (ex [k'] (ex [u'] (hasattr_ext i (rec/dynamic k' u')))
		  (and
		     (inrole k (doctor k') u)
		     (all [k1][d1][u1] (hasattr_ext i (rec/dynamic/medicalrecord/private k1 d1 u1))
			(eq_prin d1 k)))))

	    (<POL/ACC/PHYSIO> %% Positive norm for physiotherapists
	       or
	       (ex [i][k] (eq_action a (read k i))
		  (ex [k'][u'] (hasattr_ext i (rec/dynamic k' u'))
		     (and 
                        %% k must be in the role of physiotherapist of k'
			(ex [d] (refer-physio d k k' u)
			   (inrole d (doctor k') u))
			%% i must not be private
			(all [k1][d1][u1] (hasattr_ext i (rec/dynamic/medicalrecord/private k1 d1 u1))
			   false))))
	       (ex [i][k] (eq_action a (add k i))
		  (ex [k'] (hasattr_ext i (rec/dynamic/medicalrecord/rehab k' k u))
		     %% k must be in the role of physiotherapist of k'
		     (ex [d] (refer-physio d k k' u)
			(inrole d (doctor k') u)))))
		  
	    (<POL/ACC/MANAGER> %% Positive norm for manager
	       or
	       (ex [i][k] (eq_action a (read k i))
		  (and
		     (inrole k manager u)
		     (all [k1][d1][u1] (hasattr_ext i (rec/dynamic/medicalrecord/private k1 d1 u1))
			false)))
	       (ex [i][k] (eq_action a (write k i))
		  (and 
		     (inrole k manager u)
		     (or
			(ex [k'] (hasattr_ext i (rec/static k'))
			   (all [k''] (hasattr_ext i (rec/static/pastmedical k''))
			      false))
			(ex [k'] (ex [u'] (hasattr_ext i (rec/dynamic/careplan k' u')))
			   (or 
			      (allows k' a u)
			      (and
				 (ex [p] (allows p a u)
				    (inrole p (pr k') u))
				 (or
				    (emergency k' u)
				    (mentally-incapable k' u))))))))
	       (ex [i][k] (eq_action a (add k i))
		  (and 
		     (inrole k manager u)
		     (or
			(ex [k'] (hasattr_ext i (rec/static k'))
			   (beginrole k' resident u))
			(ex [k'] (hasattr_ext i (rec/dynamic/progressnotes k' u))
			   true)
			(ex [k'] (hasattr_ext i (rec/dynamic/careplan k' u))
			   (or 
			      (allows k' a u)
			      (and
				 (ex [p] (allows p a u)
				    (inrole p (pr k') u))
				 (or
				    (emergency k' u)
				    (mentally-incapable k' u))))))))	       
	       (ex [i][k] (eq_action a (delete k i))
		  (and 
		     (inrole k manager u)
		     (ex [k'] (hasattr_ext i (rec k'))
			(ex [u'] (endrole k' resident u')
			   (lessthan (plus u' seven_year) u))))))

	    (<POL/ACC/ADMINSTAFF> %% Positive norm for adminstaff
	       or
	       (ex [i][k] (eq_action a (read k i))
		  (and
		     (inrole k adminstaff u)
		     (ex [k'] 
			(or 
			   (hasattr_ext i (rec/static/personal k'))
			   (hasattr_ext i (rec/static/emergency k')))
			true)))
	       (ex [i][k] (eq_action a (write k i))
		  (and 
		     (inrole k adminstaff u)
		     (ex [k'] 
			(or
			   (hasattr_ext i (rec/static/personal k'))
			   (hasattr_ext i (rec/static/emergency k')))
			(incorrect k' i u))))
	       (ex [i][k] (eq_action a (add k i))
		  (and
		     (inrole k adminstaff u)
		     (ex [k'] (hasattr_ext i (rec/static k'))
			(beginrole k' resident u)))))
			   
	    (<POL/ACC/NURSE> %% Positive norm for nurses
	       or
	       (ex [i][k] (eq_action a (read k i))
		  (and 
		     (inrole k nurse u)
		     (ex [k'][u'] (hasattr_ext i (rec/dynamic k' u'))
			(all [d1][k1][u1] (hasattr_ext i (rec/dynamic/medicalrecord/private k1 d1 u1))
			   false))))
	       (ex [i][k] (eq_action a (add k i))
		  (and
		     (inrole k nurse u)
		     (ex [k'] (hasattr_ext i (rec/dynamic/progressnotes k' u)) true))))

	    (<POL/ACC/HCW> %% Positive norm for health-care workers
	       or
	       (ex [i][k] (eq_action a (read k i))
		  (and 
		     (inrole k hcw u)
		     (ex [k'][u'] (hasattr_ext i (rec/dynamic k' u'))
			(and
			   (all [d1][k1][u1] (hasattr_ext i (rec/dynamic/medicalrecord/private k1 d1 u1))
			      false)
			   (or
			      (lessthan u (plus u' one_year))
			      (ex [m] (allows m a u)
				 (inrole m manager u)))))))
	       (ex [i][k] (eq_action a (add k i))
		  (and
		     (inrole k hcw u)
		     (ex [k'] (hasattr_ext i (rec/dynamic/progressnotes k' u)) true))))

	    (<POL/ACC/VOLUNTEER> %% Positive norm for volunteers
	       or
	       (ex [i][k] (eq_action a (read k i))
		  (and
		     (inrole k volunteer u)
		     (ex [k'] (hasattr_ext i (rec/static/emergency k'))
			true)))
	       (ex [i][k] (eq_action a (add k i))
		  (and
		     (inrole k volunteer u)
		     (ex [k'] (hasattr_ext i (rec/dynamic/progressnotes k' u))
			true))))

	    (<POL/ACC/LAW/REQ> %% Allow disclosure to law officers and responses to requests
	       ex [k][i][k'] (eq_action a (disclose k i k'))
	       (ex [k''] (hasattr_ext i (rec k''))
		  (and 
		     (inrole k manager u)
		     (or
			(and 
			   (is-law-official k' u)
			   (believes-victim-of-abuse k k'' u))
			(and
			   (eq_prin k' k'')
			   (ex [u'] (request k'' u')
			      (lessthan u' u)))))))))

      (<POL/REQ> 
      %% Negative norm for requests -- manager must respond in 30 days
      %% to requests from patients within last 7 years
      	 all [k][u] (request k u)
      	 (or (violated_request k u)
            %% Either k's resident role ended for the last time more
            %% than seven years ago
      	    (ex [u'] (endrole k resident u')
      	       (and 
      		  (lessthan (plus u' seven_year) u)
      		  (all [u''] (beginrole k resident u'')
      		     (lessthan u'' u'))))
            %% Or, a manager discloses to k within 30 days
      	    (ex [u''][i][k'] (does (disclose k' i k) u'')
      	       (and
      		  (lessthan u'' (plus u thirty_day))
      		  (inrole k' manager u'')))))
		  
      (<POL/SIGNEDCONF>
      %% Negative norm for confidentiality agreements: managers, hcws,
      %% adminstaff, nurses, and volunteers must sign confidentiality
      %% agreements when they begin their roles
      	 all [k][r][u] 
      	 (and
      	    (beginrole k r u)
      	    (or
      	       (eq_role r manager)
      	       (eq_role r hcw)
      	       (eq_role r adminstaff)
      	       (eq_role r nurse)
      	       (eq_role r volunteer)))
      	 (or (violated_conf k r u)
             (ex [u'] (signed-conf k u')
      	        (lessthan u' u))))

         true
