%% Copyright (c) <2011>, <Limin Jia, liminjia@cmu.edu>
%% All rights reserved.
%%
%% Use in source and binary forms, with or without modification, are
%% permitted provided that the following conditions are met:
%%
%% - Code derived from this source code must retain the above copyright
%%   notice, this list of conditions and the following disclaimer.
%%
%% - Use or modification is not done for any commercial purpose or for
%%   monetary gain
%%
%% Redistribution without permission of original copyright holder is
%% prohibited.
%%
%% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
%% "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
%% LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
%% A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
%% HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
%% SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
%% LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
%% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
%% THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%% (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
%% OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%% Sorts 
attr: sort. 
prin: sort. 
info: sort. 
role: sort. 
purpose: sort.
message: sort.
relation: sort.

%% Principals
str2prin: string -> prin.

%% Info
str2info: string -> info.

%% Message
str2msg: string -> message.
msg: info -> purpose -> message.
req: prin -> attr -> message.

%% relations
str2rel: string -> relation.

%% Atributes
str2attr: string -> attr.

phi: attr. %%  protected health info.
name-and-addr: attr.
postal-addr:attr.
info-164-512-f2i: attr.
directory-info: attr.
demographic-info: attr.

workplace-injury-findings: attr.
medical-surveillance-findings: attr.
medical-suitability: attr.

psychotherapy-notes: attr. 

ABO-blood-type-and-rh-factor: attr.
type-of-injury: attr.
date-and-time-of-death: attr.
distinguishing-physical-characteristics: attr.
location-condition-death: attr.

name :attr.
ssn: attr.
city-state-zipcode: attr.
telephone-number :attr.
date-and-place-of-birth: attr.
fax-number :attr.
email-addr :attr.

date-and-time-of-treatment: attr.
religious-affiliation: attr.
healthcare-dates: attr.

medical-record-number :attr.
health-plan-beneficiary-number :attr.
account-numbers :attr.
license-numbers :attr.
vehicle-id :attr.
device-id :attr.
URLs :attr.
ip-addr :attr.
biometric-id :attr.
full-face-image :attr.


%% Purposes
str2purp: string -> purpose.
Treatment: purpose.
Payment: purpose.
Healthcare-op: purpose.
research: purpose.
public-health: purpose.
treatment : prin -> purpose.
%% treatment p -- treatment activities of principal p
payment: prin -> purpose.
%% payment p -- payment activities of principal p
healthcare-op: prin -> purpose.
%% healthcare-op p -- health-care operations of principal p
healthcare-op-para-1-2: prin -> purpose.
%% healthcare-op-para-1-2 p -- a purpose listed in the definition of healthcare operations paragraph 1,2 
healthcare-fraud-abuse-detection: purpose.
healthcare-fraud-abuse-compliance: purpose.
counseling-training-programs: prin -> purpose.
defense-in-legal-proceeding: prin -> prin -> purpose.
marketing: purpose.
lessen-health-threat: purpose.
id: prin -> purpose.
%% id p -- for the purpose of identifying p
determine-cause-of-death: prin -> purpose.
%% dertermine-cause-of-death p -- for the purpose of determining the cause of death of p
compliance-investigation: prin -> purpose.
%% compliance-investigation p -- for the purpose of investigating the compliance of principal p
Oversight: purpose.
reports-of-abuse: purpose.
judicial-admin-proceeding: purpose.
suspicious-death-notification: prin -> purpose. 
%%  sus... p -- notification of suspicious death of p
report-possible-crime-on-premises: prin -> purpose.
alert-of-crime-commission-location-victims-perpetrator: purpose.
law-enforcement: purpose.
law-enforcement-relevant-id-or-location: prin -> purpose.
%% law... p -- for the purpose of identification or location of p
directory: purpose.
coordinate-disclosure-under-164-510b1ii: purpose.
notification-164-510b: purpose.
assist-notification-164-510b: purpose.
facilitate-organ-eye-tissue-donation-transplantation: purpose.

fundraising: purpose. 
health-insurance-contact-creation: purpose.
health-insurance-contact-renewal: purpose.
health-insurance-contact-replacement: purpose.

over-sight-government-benefit-programs-health-eligibility:purpose.
over-sight-government-regulated-entity-health-compliance:purpose.
over-sight-subject-to-civil-rights-health-compliance:purpose.

disease-prevention-control:purpose.
public-health-surveillance:purpose.
public-health-investigation:purpose.
public-health-intervention:purpose.
reports-of-child-abuse: purpose.
quality-safety-effectiveness-activities: prin -> purpose.
notify-for-public-health-intervention: purpose.
obligation-to-record-workplace-injury: purpose.
obligation-to-perform-medical-surveillance: purpose.

funeral-directory-duties: prin -> purpose. 
id-apprehend: prin -> purpose.
eligibility-determination-for-veterans-benefits: purpose.
provision-of-veterans-benefits: purpose.
national-security-activities: purpose.
conduct-investigations-18USC871-and-879: purpose.
provision-of-protective-services: purpose.

security-clearance-EO-10450-and-12698: purpose.
determine-availability-for-foreign-service-FSA-101a4-and-504: purpose.
determine-family-accompaniment-FSA-101b5-and-904: purpose.

create-deidentified-info: purpose.
determine-eligibility-enrollment: purpose.
report-unethical-conduct-allegations: prin -> prin -> purpose.
determine-legal-options: prin -> prin -> purpose.

%% Roles
str2role: string -> role.

covered-entity:role.
health-plan:role.

health-care-provider: prin -> role.
%% health-care provider p -- the health care provider of p
Health-care-provider: role.

participant-of-organized-health: prin -> role.
%% participant-of-organized-health p -- a participant of organized health arrangment p

researcher: role.
institutional-review-board: prin -> role.
privacy-board: prin -> prin -> prin -> attr -> purpose -> role.
coroner: role.
medical-examiner: role.
secretary: role.
% court: role.
% admin-tribunal: role.

personal-rep: prin -> role. 
%% personal representitive of p

family-member: prin -> role. 
relative: prin -> role. 
close-personal-friend : prin -> role. 
responsible-for-care: prin -> role. 
identified-164-510b: prin -> role. 

business-assoc: prin -> role.
related-foundations: prin -> role.
responsible-for-product: prin -> role.
employer: role.
funeral-director: role.

organ-procurement-organization : role.
engaged-in-procurement-banking-transplantation-of-organs-eyes-tissue: role. 
DVA: role.
component-of-DVA: role.
component-of-DoS: role.
DoS-official: role.
government-public-benefits-program: role.

parent: prin -> role.
guardian: prin -> role.
in-loco-parentis: prin -> role.
gov-health-plan: role.
agency: role.
group-health-plan: role.
sponsor: prin ->role.
oversight-agency: role.
public-health-authority: role. %% inconsistent with is-public-health-authority
healthcare-accreditation-org: role.
attorney: prin -> role.

organized-healthcare-arrangement: role.
health-oversight-agency: role.
goverment-authority: role.
law-enforcement-official: role.
victim-of-crime: role.
suspected-victim-of-crime: role.
clergy: role.
foreign-gov-agency: role.
gov-authority: role.
armed-forces-personnel: role. 
foreign-military-personnel:   role. 
component-of-DoD-or-DoT: role.
armed-forces-memeber: role. 
authorized-fed-official: role. 
correctional-institution: role.


%%% Dates

%%% Add a relative time (int) to a date
plus: date -> int -> date EVAL.

prompt: int. 
%% a time interval that is considered to be prompt
t_reasonable: int.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

%%% DB predicates

%% timeline_db: time(+) -> pred DB
%% %dbinfo "timeline_db" ("time").

attr_in_db: attr(+) -> attr(+) -> date(+) -> pred DB
%dbinfo "attr_in_db" ("subattr", "supattr", "time").

disclose: prin(-) -> prin(-) -> message(-) -> date(-) -> pred DB
%dbinfo "disclose" ("sender", "receiver", "message", "time").
%% disclose p1 p2 m u -- p1 disclose p2 message m at time u.

request: prin(-) -> prin(-) -> message(-) -> date(-) -> pred DB
%dbinfo "disclose" ("sender", "receiver", "message", "time").
%% disclose p1 p2 m u -- p1 disclose p2 message m at time u.

hasattrof_db: info(+) -> prin(-) -> attr(-) -> date(-) ->pred DB
%dbinfo "hasattrof_db" ("info", "principal", "attribute", "time").

inrelation: prin(+) -> prin(+) -> relation(-) -> date(-) -> pred DB
%dbinfo "inrelation" ("patient", "hospital", "relation", "time").
%%inrelation p1 p2 r u -- p1 and p2 has relation r at time u

inrole_db: prin(+) -> role(+) -> date(-) -> pred DB
%dbinfo "inrole_db" ("principal", "role", "time").

is-participant-of-organized-health: prin(+) -> prin(-) -> date(+) -> pred DB
%dbinfo "is_participant_of_organized_health" ("principal", "organizedhealth", "time").
%% is... p1 p2 u -- p1 is a participant of organized health p2

is-workforce-member: prin(+) -> prin(-) -> date(+) -> pred DB
%dbinfo "is_workforce_member" ("employee", "employer", "time").
%% is-workforce-member p1 p2 u -- p1 is a workforce member of p2 at time u

purp_in_db: purpose(+) -> purpose(+) -> date(-) -> pred DB
%dbinfo "purp_in_db" ("subpurpose", "suppurpose", "time").

send: prin(-) -> prin(-) -> message(-) -> date(-) -> pred DB
%dbinfo "send" ("sender", "receiver", "message", "time").
%% send p1 p2 m u -- p1 sends p2 message m at time u.

%%% less frequently used predicates
beginrole: prin(-) -> role(-) -> date(-) -> pred DB
%dbinfo "beginrole" ("principal", "role", "time").

deceased: prin(+) -> date(-) -> pred DB
%dbinfo "deceased" ("principal", "time").
%% deceased p u -- p is deceased at time u

deemed-necessary-for-mission:  prin(-) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+)  -> date(-) -> pred DB
%dbinfo "deemed_necessary_for_mission" ("authority", "sender", "receiver", "principal", "attribute", "purpose", "time").
%% deemed... p3 p1 p2 p t pp u -- p3 deemed disclosure from p1 to p2 ... is necessary for mission

determines-eligibility-enrollment: prin(+) -> prin(+) -> date(+) -> pred DB
%dbinfo "determines_eligibility_enrollemnt" ("authority", "principal", "time").

directed-disclosure:  prin(-) -> prin(-) -> prin(-) -> prin(-) -> attr(-) -> purpose(-) -> date(-)-> pred DB
%dbinfo "directed_disclosure" ("director", "sender", "receiver", "principal", "attribute", "purpose", "time").
%%directed-disclosure p' p1 p2 p t pp u -- p' directed the disclosure from p1 to p2 ... at time u

accessible-on-site: prin(+) -> prin(+) -> attr(+) -> date(+) -> pred DB
%dbinfo "accessible_on_site" ("hospital", "patient", "attribute", "time").


%% could make this an eval, and record info collected by
eligibility-enrollment-info-collected-by: prin(+) -> date(+) -> pred DB
%dbinfo "enrollemnt_info_collected_by" ("principal", "time").

endrole: prin(+) -> role(+) -> date(-) -> pred DB
%dbinfo "endrole" ("principal", "role", "time").

FDA-regulated: prin(-) -> date(+) -> pred DB
%dbinfo "FDA_regulated" ("product", "time").
%% FDA_regulated pd u -- product pd is regulated by FDA at time u

individual-has-agreed: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) ->pred DB
%dbinfo "individual_has_agreed" ("sender", "receiver", "patient", "attribute", "purpose", "time").
%% individual-has-agreed p1 p2 p t pp -- p has agreed p1's disclosure to p2 of information of attribute t for purpose pp

health-insurance-placed-with: prin(+) -> prin(+) -> date(+) -> pred DB
%dbinfo "health_insurance_placed_with" ("insurance", "principal", "time").
%% health-... p1 p2 -- health insurance p1 is placed with p2

in-lawful-custody : prin(+) -> prin(+) -> date(+) -> pred DB
%dbinfo "in_lawful_custody" ("criminal", "law", "time").

is-business-assoc: prin(+) -> prin(-) -> date(+) -> pred DB
%dbinfo "is_business_assoc" ("business", "principal", "time").
%% is-business-assoc p1 p2 u -- p1 is p2's business associate at time u

is-government-agency-administering: prin(+) -> prin(-) -> date (+) -> pred DB
%dbinfo "is_gov_agency_administering" ("admin", "principal", "time").
%% is... p1 p2 -- p1 is a gov agency administering program p2

is-health-insurance-issuer: prin(+) -> prin (-) -> date(+) -> pred DB
%dbinfo "is_health_insurance_issuer" ("issuer", "principal", "time").
%% is-health-insurance-issuer p1 p2 -- p1 is the health issurance issuer of p2

is-HMO: prin(+) -> prin (-) -> date(+)-> pred DB
%dbinfo "is_hmo" ("principal", "hmo", "time").
%% is-HMO p1 p2 -- p1 belongs to HMO group p2
%%% EVAL prdicates


is-victim-of: prin(+) -> prin(-) -> date(+)->  pred DB
%dbinfo "is_victim_of" ("principal", "crime", "time").
%% is-victim-of p c -- p is the victim of crime act c
%% for mode checking, should this be subjective?

obtain-consent: prin(-) -> prin(-) -> purpose(-) -> date(-) -> pred DB
%dbinfo "obtain_consent" ("hospital", "patient", "purpose", "time").
%% obtain-consent p1 p2 pp u -- at time u, p1 obtained consent from p2 of disclosing p2's info for purpose pp.

provides-medical-surveillance: prin(+) -> prin(+) -> date(+) -> pred DB
%dbinfo "provides_medical_surveillance" ("provider", "principal", "time").
%% provides-medical-surveillance p1 p2 u -- p1 provides p2 ... at time u

provides-medical-injury-evaluation: prin(+) -> prin(+) -> date(+) -> pred DB
%dbinfo "provides_medical_injury_evaluation" ("provider", "principal", "time").
%% provides-medical... p1 p2 u -- p1 provides p2 ... at time u

request-accepted: prin(-) -> prin(-) -> attr(-) -> date(-) -> pred DB
%dbinfo "request_accepted" ("sender", "receiver", "attribute", "time").

request-denied: prin(-) -> prin(-) -> attr(-) -> date(-) -> pred DB
%dbinfo "request_denied" ("sender", "receiver", "attribute", "time").

%%% EAVL

%% We could also define inrole in terms of beginrole and endrole and
%% just inline it, but a direct implementation might be more
%% efficient.

disclose-eval: prin(-) -> prin(-) -> message(-) -> date(-) -> pred EVAL.

inrole: prin(+) -> role(+) -> date(+) -> pred EVAL.

%% hasattr: info(+) -> attr(-) -> pred EVAL.
hasattrof: info(+) -> prin(-) -> attr(-) -> pred EVAL.
sub_attr: attr(-) -> attr(+) -> pred EVAL.
attr_in: attr(+) -> attr(+) -> pred EVAL.


eq_prin: prin(+) -> prin(-) -> pred EVAL.
eq_msg: message(+) -> message(-) -> pred EVAL.
lessthan: date(+) -> date(+) -> pred EVAL.
time_in: date(+) ->  date(+) -> date(+) -> pred EVAL. 
%% time_in u3 u1 u2 -- u1 < u3 <= u2
%% time_ge: date(-) -> date(+) -> pred EVAL.

purp_in: purpose(+) -> purpose(+) -> pred EVAL.
%% not_purp_in: purpose(+) -> purpose(+) -> pred SUBJ.

%%% SUBJ predicates
%% purp_in: purpose(+) -> purpose(+) -> pred SUBJ.
%% not_purp_in: purpose(+) -> purpose(+) -> pred SUBJ.

was-armed-forces-memeber:  prin(+) -> date(+) -> pred SUBJ.

belongrole: prin(+) -> role (+) -> date(+) -> pred SUBJ.
%% belongrole p r u -- principal p belongs to role r at time u

pertain_to: attr(+) -> relation(+) -> date(+) -> pred SUBJ.
%% pertain_to t r -- t pertains to relation r

is-valid-authorization-508: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% is-valid-authorization m p1 p2 p t pp --
%% m is a valid authorization of p1 disclosing to p2 p's record of attribute t for purpose pp

face-to-face-comm: prin(+) -> prin(+) -> prin(+) -> purpose(+) -> date(+) -> pred SUBJ.
promotional-gift-of-nominal-val: prin(+) -> prin(+) -> prin(+) -> purpose(+) -> date(+) -> pred SUBJ.

is-required-by-law: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% is-required-by-law p1 p2 p t pp -- p1 is required by law to disclose p's information of attribute t to p2 for purpose pp

consistent-with-applicable-law: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.

believes-necessary-to-lessen-health-threat: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.

believes-can-lessen-threat: prin(+) -> prin(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% believes-can-lessen-threat p1 p2 pp -- p1 believes disclosing to p2 for purpose pp can lessen threat

authorized-by-law: prin(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% authorized-by-law p pp -- disclosing to principal p for purpose pp is authorized by law

believes-notice-would-risk-indivdual: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% believes... p1 p2 p t pp -- p1 believes that informing p of disclosure to p2, information of attribute t for purpose pp would risk the individual

would-inform-pr: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
 %% would-inform-pr p1 p2 p t pp --  p1 would be informing p's persoNal representitive on the disclosure of information of attribute t for purpose pp to p2.

believes-pr-responsible: prin(+) -> prin(+) -> date(+) -> pred SUBJ.
 %% believes... p1 p -- p1 believes that p's personal representitive is responsiblefor the abuse, neglect or injury

believes-informing-is-not-in-the-best-interest: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% believes... p1 p2 p t pp -- p1 believes that informing p of the disclosure of information of attribute t for purpose pp to p2 is not in the best interest of p

is-notice-of-report: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% is... m p1 p2 p t pp -- m is a notice of p1 report to p2, p's information of attribute t for purpose pp

authorized-by-law-to-receive: prin(+) -> purpose(+) -> date(+)  -> pred SUBJ.
%% authorized-by-law-to-receive p pp -- p is authorized by law to recieve messages for purpose pp.

believes-victim-of-abuse: prin(+) -> prin(+)  -> date(+)   -> pred SUBJ.
%% beleives.. p1 p2 -- p1 believes p2 is a victim of abuse

is-requred-by-law: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% is-reuqired-by-law p1 p2 p t pp -- p1 is required by law to disclose to p2 p's information of attribute t for purpose pp

authorized-by-statue-regulation: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.

believes-disclosure-necessary-to-prevent-harm : prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.

assurance-disclosure-not-used-against-individual: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.

believes-waiting-for-agreement-would-hinder-enforcement: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.

incapacitated: prin(+) -> pred SUBJ.

is-lawful-process: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% is-lawful-precess m p1 p2 p t pp -- m' shows that requesting p1 to disclose information about p of attribute t for purpose pp is a lawful process

made-reasonable-effort-to-notify: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.

is-order: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> date(+) -> pred SUBJ.
%% is-order m p1 p2 p t -- m is an order of p1 disclosing p's info to p2

received-satisfactory-assurance-164/512e1iii: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
received-satisfactory-assurance-164/512e1iv: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+)-> date(+) -> pred SUBJ.


believes-death-may-be-result-of-crime: prin(+) -> prin(+) -> date(+) -> pred SUBJ.
%% believes... p1 p -- p1 believes p's death may be result of crime
believes-evidence-of-crime-on-premises:  prin(+) -> prin(+) -> attr(+) -> date(+) -> pred SUBJ.
%% believes... p1 p t -- p1 believes p's information of attribute t constitutes evidence of criminal conduct occurred on the premise of p1

providing-emergency-healthcare: prin(+) -> prin(+) -> date(+) -> pred SUBJ.
%% providing-emergency-healthcare p1 p -- p1 is providing emergency care to p

appears-necessary-to-alert-of-crime-commission-location-victims-perpetrator:
  prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
not-believes-emergency-result-of-abuse-neglect-domestic-violence: prin(+) -> prin(+) -> date(+) -> pred SUBJ.
%% not-believes... p1 p2 -- it is not the case that p1 believes p's emergency is the result of....

required-by-law: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% required-by-law p1 p2 p t pp -- p1 is required by law to disclose to p2 info about p of attribute t for purpose pp

in-compliance-with-court-order: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
in-compliance-with-grand-jury-subpoena: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)  -> pred SUBJ.
in-compliance-with-admin-request: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
			      
minimum-necessary: prin(+) -> prin(+) -> message(+) -> purpose(+) -> date(+) -> pred SUBJ. 
%% minimus-necessary p1 p2 m pp -- p1's disclosure of m to p1 for purpose pp is minimal

deidentied-info-not-sufficient: purpose(+) -> date(+) -> pred SUBJ. 
%% deidentied-info-not-sufficient pp -- deidentified info is not enough for purpose pp

is-request-for: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% is-request-for m p1 p2 p t pp -- m is a request from p1 to p2 about p's info of attr t for purpose pp.

is-agreement-to: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% is-agreement-to m p1 p2 p t pp -- m is an agreement that p allows p1 to disclose to p2 about p's info of attr t for purpose pp.

is-emergency: prin(+) -> date(+) ->  pred SUBJ.
%% is-emergency p -- p has an emergency
represents-needed-to-determine-crime: prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% represents... p2 p1 p2 p t pp -- p2 represents that info is needed...
represents-not-used-against-victim: prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% represents... p2 p1 p t pp -- p2 represents

represents-activity-adversely-affected-by-waiting: prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+)-> date(+)  -> pred SUBJ.
%% represents... p2 p1 p2 p t pp -- p2 represents

believes-in-best-interest: prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% believes... p1 p1 p2 p t pp -- p1 belives...

is-directory-request-by-name: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+)-> date(+)  -> pred SUBJ.
%% is-directory-request-by-name m' p2 p1 p t pp -- m' is a request from p2 to p1 with p's name for attribute t, purpose pp

is-opportunity-to-object-164-510a: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% is... m p1 p2 p t pp -- m allows p an opportunity to object p1 send info of attribute t to p2 for purpose pp

is-not-directory-objection-164-510a: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%% is... m p1 p2 p t pp -- m is p's objection of p1 disclosing to p2 p's directory info for purpose pp

is-not-incapacitated: prin(+) -> date(+) -> pred SUBJ.
not-under-emergency-treatment:  prin(+) -> date(+) -> pred SUBJ.
consistent-with-prior-pref: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ. 
believes-in-best-interest-510-3iB: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ. 
not-practical-to-provide-opp-to-object-164-510a: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)->  date(+)-> pred SUBJ. 
never-practical-to-provide-opp-to-object-164-510a: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ. 

is-authorized-by-law-or-charter-to-assist-disaster-relief: prin(+) -> date(+)-> pred SUBJ. 
prof-judgment-reqs-interfere-with-emergency-response: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ. 

relevant-to-involvement: attr(+) -> prin(+) -> prin(+) -> date(+) -> pred SUBJ.
%% relevant-to-involvement t p2 p -- attribute t is relevant to involve p2 in the treatment of p


Available: prin(+) -> prin(+) -> date(+) -> pred SUBJ.
%% available p1 p u -- p is available to p1 at time u
NotAvailable: prin(+) -> prin(+) -> date(+) -> pred SUBJ.

has-capacity-to-make-health-care-decisions: prin(+) -> date(+) -> pred SUBJ.
Has-capacity-to-make-health-care-decisions: prin(+) -> date(+) -> pred SUBJ.
Not-Has-capacity-to-make-health-care-decisions: prin(+) -> date(+) -> pred SUBJ.

has-obtained-agreement-164-510-b2: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  
has-provided-opportunity-to-objection-164-510-b2: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  
professional-judgment-individual-does-not-object: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  

professional-judgment-is-in-best-interest-of-164-510-b3: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.  

is-limited-data-use-agreement: message(+) -> date(+) -> pred SUBJ.
contains-permitted-uses-disclosures: message(+) -> prin(+) -> prin(+) -> date(+) -> pred SUBJ.
contains-permitted-recipients: message(+) -> prin(+) -> prin(+) -> date(+) -> pred SUBJ.
contains-agreement-to-no-further-disclosures: message(+) -> prin(+) -> prin(+) -> date(+)  -> pred SUBJ.
contains-agreement-to-safeguards: message(+) -> prin(+) -> prin(+) -> date(+) ->  pred SUBJ.
contains-agreement-to-report-further-disclosures: message(+) -> prin(+) -> prin(+) -> date(+) -> pred SUBJ.
contains-agreement-to-subcontractor-agreements: message(+) -> prin(+) -> prin(+) -> date(+) -> pred SUBJ.
contains-agreement-to-no-contact-or-identification: message(+) -> prin(+) -> date(+) -> pred SUBJ.

is-notice-164-520-biiiB: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  
contains-statement-of-possible-fundraising: message(+) -> prin(+) -> prin(+)  -> date(+)-> pred SUBJ.
%% contains... m' p1 p2 -- m' contains statement of disclosure to p2 for possible fundraising of p1
contains-opt-out-instructions: message(+) -> prin(+) -> prin(+)  -> date(+)-> pred SUBJ.
%% contains... m' p1 p2 -- m' contains instructions of how to opt of receiving funraising communications between p1 and p2

is-authorized-by-law: prin(+) -> purpose(+)  -> date(+)-> pred SUBJ.

is-not-subject-of-investigation: prin(+)  -> purpose(+) -> date(+)-> pred SUBJ.

related-to-receipt-health-care: purpose(+) -> date(+) -> pred SUBJ.
related-to-public-health-benefits : purpose(+) -> date(+) -> pred SUBJ.
related-to-public-benefits-qualification-depends-on-health : purpose(+) -> date(+) -> pred SUBJ.

authorized-and-necessary-for-workers-compensation-laws: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  

is-at-risk-of-contracting-or-spreading-disease: prin(+) -> date(+) -> pred SUBJ. 

is-notice-of-workplace-disclosure: message(+) -> date(+) -> pred SUBJ.

early-disclosure-necessary: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  
necessary-for-duties: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  

is-admission-of-crime: message(+) -> prin(+)-> date(+)  -> pred SUBJ.
believes-crime-caused-serious-harm: prin(+) -> message(+) -> date(+)  -> pred SUBJ.
believes-escaped-lawful-custody: prin(+) -> prin(+) -> date(+)  -> pred SUBJ.

not-learned-while-treating-propensity-for-crime: prin(+) -> prin(+) -> attr(+) -> date(+) -> pred SUBJ.  
not-learned-through-request-for-treatment-of-propensity-for-crime: prin(+) -> prin(+) -> attr(+) -> date(+) -> pred SUBJ.  

%%contains: message(+) -> prin(+) -> attr(+) -> pred SUBJ.

published-in-FR-command-authority-for-disclosure: prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  
published-in-FR-purpose-for-disclosure: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.   


NSA-authorized-recipient:  prin(+) -> date(+) -> pred SUBJ. 
NSA-authorized-purpose:  purpose(+) -> date(+) -> pred SUBJ.

authorized-to-receive-protection-18USC3056: purpose(+) -> date(+) -> pred SUBJ. 
authorized-to-receive-protection-22USC2709a3: purpose(+) -> date(+) -> pred SUBJ. 

represents-necessary-for-providing-healthcare: prin(+) -> attr(+) -> date(+) -> pred SUBJ.
represents-necessary-for-health-safety-of-inmates: prin(+) -> attr(+) -> date(+) -> pred SUBJ.
represents-necessary-for-health-safety-of-employees: prin(+) -> attr(+) -> date(+) -> pred SUBJ.
represents-necessary-for-health-safety-of-transportation-officers: prin(+) -> attr(+) -> date(+) -> pred SUBJ.
represents-necessary-for-law-enforcement-on-premises: prin(+) -> attr(+) -> date(+) -> pred SUBJ.
represents-necessary-for-safety-security-order: prin(+) -> attr(+) -> date(+) -> pred SUBJ.

relates-to-eligibility-enrollment-in-health-plan: attr(+) -> prin(+) -> prin (+) -> date(+) -> pred SUBJ.
%% related... t p p1 u-- t is related to the eligibility of p's enrollment in p1 at time u

disclosure-required-or-authorized-by-statute-or-regulation : prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.   

relates-to-program: prin(+) -> attr(+) -> prin(+) -> date(+) -> pred SUBJ.   
%% relates-to-program p t p3 -- p's info t is related to program p3

serve-similar-populations: prin(+) -> prin(+) -> date(+) -> pred SUBJ.   

necessary-for-coordination: attr(+) ->  prin(+) -> prin(+) -> date(+) -> pred SUBJ.   
%% necessary-... t p p3 p4 u -- p's info of attribute t is necessary ... for programs p3 and p4

necessary-for-improve-management: attr(+) ->  prin(+) -> prin(+) -> date(+) -> pred SUBJ.   
%% necessary-... t p p3 p4 u -- p's info of attribute t is necessary ... for programs p3 and p4


permitted-by-other-laws: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  
not-prohibited-by-other-laws: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  

incident-to-use-disclose: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  

believes-minimum-necessary-for-purpose: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  
satisfactory-assurances-will-safeguard-info: prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+)-> pred SUBJ.  

requirement-of-504f-are-met: prin(+) -> date(-) -> pred SUBJ.

believes-unlawful-unethical-or-dangerous: prin(+) -> prin(+) -> date(+) -> pred SUBJ.

authorized-by-law-to-investigate-allegations: prin(+) ->  prin(+) -> prin(+) -> date(+) -> pred SUBJ.


authorized-by-court-order:  prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%%%dbinfo "authorized_by_court_order" ("sender", "receiver", "principal", "attribute", "purpose", "time").  

authorized-by-tribunal-order:  prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
%%%dbinfo "authorized_by_tribunal_order" ("sender", "receiver", "principal", "attribute", "purpose", "time"). 


is-approval-of-authorization-waiver: message(+) -> prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
represents-disclosure-solely-for-research-preparation: prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
represents-no-information-removed-during-review: prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
represents-information-necessary-for-research: prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
represents-disclosure-solely-for-decedent-research : prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
represents-disclosure-necessary-for-research: prin(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.

is-notice-of-extension: message(+) -> prin (+) -> prin (+) -> attr(+) -> date(+) -> pred SUBJ.
is-notice-of-request-accepted: message(+) -> prin (+) -> prin (+) -> attr(+) -> date(+) -> pred SUBJ.
access-provided-164-524c: prin (+) -> prin (+) -> attr(+) -> date(+) -> pred SUBJ.

is-notice-of-request-denied: message(+) -> prin (+) -> prin (+) -> attr(+) -> date(+) -> pred SUBJ.
access-denied-164-524d: prin (+) -> prin (+) -> attr(+) -> date(+) -> pred SUBJ.


may-deny-without-review-164-524a2: prin (+) -> prin (+) -> attr(+) -> date(+) -> pred SUBJ. 
may-dney-with-review-164-524a3: prin (+) -> prin (+) -> attr(+) -> date(+) -> pred SUBJ.

contains: message(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
violation: message(+) -> prin(+) -> prin(+) -> prin(+) -> attr(+) -> purpose(+) -> date(+) -> pred SUBJ.
