%% Copyright (c) <2011>, <Limin Jia, liminjia@cmu.edu>
%% All rights reserved.
%%
%% Use in source and binary forms, with or without modification, are
%% permitted provided that the following conditions are met:
%%
%% - Code derived from this source code must retain the above copyright
%%   notice, this list of conditions and the following disclaimer.
%%
%% - Use or modification is not done for any commercial purpose or for
%%   monetary gain
%%
%% Redistribution without permission of original copyright holder is
%% prohibited.
%%
%% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
%% "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
%% LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
%% A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
%% HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
%% SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
%% LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
%% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
%% THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%% (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
%% OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

<POL/DISCLOSE>
   all [p1][p2][m][u][i][pp] (and (disclose-eval p1 p2 m u) (eq_msg m (msg i pp)))
      (all [t][p] (hasattrof i p t)
	 (and
	    (contains m p t pp u)
            (or
              (violation m p1 p2 p t pp u)
              (and 
               (or %% positive norms
	        (<POL/502/a/1>
		  and
		  (attr_in t phi) 
		  (or
		     (<POL/502/a/1/i>
			and
			(inrole p1 covered-entity u)
			(or
			   (eq_prin p2 p)
			   (inrole p2 (personal-rep p) u)))
		     (<POL/502/a/1/iii> incident-to-use-disclose p1 p2 p t pp u)
		     (<POL/502/a/1/iv> 
			and
			(inrole p1 covered-entity u)
			(ex [m'][u'] (send p p1 m' u')
			   (and
			      (lessthan u' u)
			      (is-valid-authorization-508 m' p1 p2 p t pp u))))
		     (<POL/502/a/2/ii>
			and
			(inrole p1 covered-entity u)
			(inrole p2 secretary u)
			(purp_in pp (compliance-investigation p1)))))
	       (<POL/502/d/1> 
		  and
		  (inrole p1 covered-entity u)
		  (inrole p2 (business-assoc p1) u)
		  (attr_in t phi)
		  (purp_in pp create-deidentified-info))
	       (<POL/502/e>
		  and
		  (<POL/502/e/1/i> 
		     and
		     (inrole p1 covered-entity u)
		     (inrole p2 (business-assoc p1) u)
		     (attr_in t phi)
		     (satisfactory-assurances-will-safeguard-info p1 p2 p t pp u))
		  (<POL/502/e/1/ii/A> 
		     or
		     (imp (inrole p1 covered-entity u) false)
		     (imp (inrole p2 (health-care-provider p) u) false)
		     (imp (purp_in pp Treatment) false)) 
		  (<POL/502/e/1/ii/B> 
		     all [p'] 
		     (or
			(eq_prin p1 p')
			(is-health-insurance-issuer p1 p' u)
			(is-HMO p1 p' u)) 
		     (and
			(inrole p' group-health-plan u)
			(inrole p2 (sponsor p') u) 
			(requirement-of-504f-are-met p' u)) )
		  (<POL/502/e/1/ii/C> 
		     or
		     (imp (inrole p1 agency u) false)
		     (imp (inrole p2 gov-health-plan u) false)
		     (and 
			(or 
			   (eq_prin p2 p1) 
			   (imp (determines-eligibility-enrollment p1 p2 u) false)
			   (eligibility-enrollment-info-collected-by p2 u))
			(imp (purp_in pp determine-eligibility-enrollment) false))))
	       (<POL/502/g/3/ii/A> 
		  and
		  (inrole p1 covered-entity u)
		  (or
		     (inrole p2 (parent p) u)
		     (inrole p2 (guardian p) u)
		     (inrole p2 (in-loco-parentis p) u))
		  (attr_in t phi)
		  (permitted-by-other-laws p1 p2 p t pp u))
	       (<POL/502/j/1>
		  and
		  (attr_in t phi)
		  (ex [p'] 
		     (or
			(is-workforce-member p1 p' u)
			(is-business-assoc p1 p' u))
		     (and
			(inrole p' covered-entity u)
			(believes-unlawful-unethical-or-dangerous p1 p' u)
			(or
			   (and
			      (or
				 (inrole p2 oversight-agency u)
				 (inrole p2 public-health-authority u))
			      (authorized-by-law-to-investigate-allegations p2 p1 p' u))
			   (and
			      (inrole p2 healthcare-accreditation-org u)
			      (purp_in pp (report-unethical-conduct-allegations p1 p')))
			   (and
			      (inrole p2 (attorney p1) u)
			      (purp_in pp (determine-legal-options p p')))))))
	       (<POL/502/j/2> 
		  and
		  (attr_in t info-164-512-f2i)
		  (belongrole p2 law-enforcement-official u)
		  (ex[c] (is-victim-of p1 c u)
		     (ex[p'](is-workforce-member p1 p' u)
			(inrole p' covered-entity u))))
	       (<POL/506/b/1>
		  ex [u'] (obtain-consent p1 p pp u') 
		  (and 
		     (lessthan u' u)
		     (inrole p1 covered-entity u)
		     (attr_in t phi)
		     (or 
			(purp_in pp Treatment)
			(purp_in pp Payment)
			(purp_in pp Healthcare-op))))
	       (<POL/506/c/1> 
		  and 
		  (attr_in t phi)
		  (inrole p1  covered-entity u)
		  (is-workforce-member p2 p1 u)
		  (or 
		     (purp_in pp (treatment p1))
		     (purp_in pp (payment p1))
		     (purp_in pp (healthcare-op p1))))
	       (<POL/506/c/2>
		  and 
		  (attr_in t phi)
		  (inrole p1 covered-entity u)
		  (inrole p2 (health-care-provider p) u)
		  (purp_in pp (treatment p2)))
	       (<POL/506/c/3> 
		  and 
		  (attr_in t phi)
		  (inrole p1 covered-entity u)
		  (or 
		     (inrole p2 (health-care-provider p) u)
		     (inrole p2 covered-entity u))
		  (purp_in pp (payment p2)))
	       (<POL/506/c/4> 
		  and 
		  (attr_in t phi)
		  (inrole p1 covered-entity u)
		  (inrole p2 covered-entity u)
		  (or 
		     (purp_in pp (healthcare-op-para-1-2 p2))
		     (purp_in pp healthcare-fraud-abuse-detection)
		     (purp_in pp healthcare-fraud-abuse-compliance))
		  (ex [r1][u'] (inrelation p p1 r1 u')
		     (and
			(lessthan u' u)
			(pertain_to t r1 u)
			(ex [r2][u''] (inrelation p p2 r2 u'')
			   (and
			      (lessthan u'' u)
			      (pertain_to t r2 u))))))
	       (<POL/506/c/5> 
		  and 
		  (attr_in t phi)
		  (inrole p1 covered-entity u)
		  (inrole p2 covered-entity u)
		  (ex [p3] (is-participant-of-organized-health p1 p3 u)
		     (and
			(belongrole p3 organized-healthcare-arrangement u)
			(is-participant-of-organized-health p2 p3 u)
			(purp_in pp (healthcare-op p3)))))
	       (<POL/510/a>
		  and
		  (<POL/510/a/1/ii>
		     and 
		     (attr_in t directory-info)
		     (inrole p1 covered-entity u)
		     (or
			(belongrole p2 clergy u) %% Henry used active role
			(and 
			   (imp (attr_in t religious-affiliation) false)
			   (ex [m'][u'] (send p2 p1 m' u')
			      (and 
				 (lessthan u' u)
				 (is-directory-request-by-name m' p2 p1 p t pp u)))))
		     (purp_in pp directory))
		  (or 
		     (<POL/510/a/2> 
			ex[m'][u'] (send p1 p m' u')
			(and 
			   (lessthan u' u)
			   (is-opportunity-to-object-164-510a m' p1 p2 p t pp u)
			   (all [u''][m''] (and  (send p p1 m'' u'' ) (time_in u'' u' u))
			      (is-not-directory-objection-164-510a m'' p1 p2 p t pp u))))
		     (and
			(<POL/510/a/3/i> 
			   and
			   (or (is-not-incapacitated p u) 
			      (not-under-emergency-treatment p u) )
			   (consistent-with-prior-pref p1 p2 p t pp u)
			   (believes-in-best-interest-510-3iB p1 p2 p t pp u))
			(<POL/510/a/3/ii> 
			   or
			   (ex[u'][m'] (send p1 p m' u')
			      (and
				 (lessthan u u')
				 (is-opportunity-to-object-164-510a m' p1 p2 p t pp u)
				 (not-practical-to-provide-opp-to-object-164-510a p1 p2 p t pp u u')))
			   (never-practical-to-provide-opp-to-object-164-510a p1 p2 p t pp u)))))
	       (<POL/510/b>
		  or 
		  (and
		     (or
			(<POL/510/b/1/i> 
			   and
			   (attr_in t phi)
			   (inrole p1 covered-entity u)
			   (or 
			      (inrole p2 (family-member p) u)
			      (inrole p2 (relative p) u)
			      (inrole p2 (close-personal-friend p) u)
			      (inrole p2 (identified-164-510b p) u))
			   (relevant-to-involvement t p2 p u))
			(<POL/510/b/1/ii> 
			   and
			   (inrole p1 covered-entity u)
			   (or 
			      (inrole p2 (family-member p) u)
			      (inrole p2 (personal-rep p) u) %% 502/a/1 makes is redundent
			      (inrole p2 (responsible-for-care p) u))
			   (or
			      (and 
				 (attr_in t location-condition-death)
				 (purp_in pp notification-164-510b))
			      (and
				 (attr_in t phi)
				 (purp_in pp assist-notification-164-510b)))))
		     (and
			(<POL/510/b/2>  %% different from Henry's to pass mode checking
			   or 
			   (or 
			      (NotAvailable p1 p u) 
			      (Not-Has-capacity-to-make-health-care-decisions p u))
			   (and
			      (has-obtained-agreement-164-510-b2 p1 p2 p t pp u)
			      (has-provided-opportunity-to-objection-164-510-b2 p1 p2 p t pp u)
			      (professional-judgment-individual-does-not-object p1 p2 p t pp u)))
			(<POL/510/b/3> 
			   or
			   (and (Available p1 p u) (Has-capacity-to-make-health-care-decisions p u))
			   (and
			      (professional-judgment-is-in-best-interest-of-164-510-b3 p1 p2 p t pp u)
			      (relevant-to-involvement t p2 p u)))))
		  (<POL/510/b/4> 
		     and
		     (attr_in t phi) 
		     (and
			(inrole p1 covered-entity u)
			(is-authorized-by-law-or-charter-to-assist-disaster-relief p2 u)
			(purp_in pp coordinate-disclosure-under-164-510b1ii)) 
		     (or
			(prof-judgment-reqs-interfere-with-emergency-response p1 p2 p t pp u) %% negation of Henry's encoding
			(and
			   (<POL/510/b/2>  %% different from Henry's to pass mode checking
			      or 
			      (or 
				 (NotAvailable p1 p u) 
				 (Not-Has-capacity-to-make-health-care-decisions p u))
			      (and
				 (has-obtained-agreement-164-510-b2 p1 p2 p t pp u)
				 (has-provided-opportunity-to-objection-164-510-b2 p1 p2 p t pp u)
				 (professional-judgment-individual-does-not-object p1 p2 p t pp u)))
			   (<POL/510/b/3> 
			      or
			      (and (Available p1 p u) (Has-capacity-to-make-health-care-decisions p u))
			      (and
				 (professional-judgment-is-in-best-interest-of-164-510-b3 p1 p2 p t pp u)
				 (relevant-to-involvement t p2 p u)))))))
	       (<POL/512/a> 
		  and
		  (attr_in t phi) 
		  (inrole p1 covered-entity u)
		  (is-required-by-law p1 p2 p t pp u)
		  ( or %% other negative forms
		     (<POL/512/c> 
			and
			(<POL/512/c1> 
			   and
			   (inrole p1 covered-entity u)
			   (belongrole p2 goverment-authority u)
			   (authorized-by-law-to-receive p2 pp u) 
			   (believes-victim-of-abuse p1 p u)
			   (purp_in pp reports-of-abuse) 
			   (or 
			      (is-requred-by-law p1 p2 p t pp u)
			      (individual-has-agreed p1 p2 p t pp u)
			      (and 
				 (authorized-by-statue-regulation p1 p2 p t pp u)
				 (or 
				    (believes-disclosure-necessary-to-prevent-harm p1 p2 p t pp u)
				    (and
				       (incapacitated p)
				       (assurance-disclosure-not-used-against-individual p1 p2 p t pp u)
				       (believes-waiting-for-agreement-would-hinder-enforcement p1 p2 p t pp u))))))
			(or 
			   (<POL/512/c2> 
			      ex[m'][u'] (send p1 p m' u')
			      (and 
				 (is-notice-of-report m' p1 p2 p t pp u)
				 (or
				    (lessthan u u')
				    (lessthan u' (plus u  prompt)))))
			   (<POL/512/c2/i> 
			      believes-notice-would-risk-indivdual p1 p2 p t pp u)
			   (<POL/512/c2/ii>%% different from Henry's encoding
			      or 
			      (and 
				 (would-inform-pr p1 p2 p t pp u)
				 (believes-pr-responsible p1 p u)) 
			      (believes-informing-is-not-in-the-best-interest p1 p2 p t pp u)))) 
		     (<POL/512/e> 
			or
			(<POL/512/e/1/i>  
			   and 
			   (inrole p1 covered-entity u)
			   (purp_in pp judicial-admin-proceeding) 
			   (or 
			      (authorized-by-court-order p1 p2 p t pp u)
			      (authorized-by-tribunal-order p1 p2 p t pp u)))
		     %% different from Henry's encoding. don't think we need to treat court as a role
			(<POL/512/e/1/ii> 
			   and 
			   (inrole p1 covered-entity u)
			   (purp_in pp judicial-admin-proceeding)
			   (ex[m'][u'] (send p2 p1 m' u')
			      (and 
				 (lessthan u' u)
				 (is-lawful-process m' p1 p2 p t pp u)
			      %% could expand definition
				 (received-satisfactory-assurance-164/512e1iii p1 p2 p t pp u)
				 (received-satisfactory-assurance-164/512e1iv p1 p2 p t pp u))))
			(<POL/512/e/i/vi> 
			   and 
			   (inrole p1 covered-entity u) 
			   (purp_in pp judicial-admin-proceeding)
			   (ex[m'][u'] (send p2 p1 m' u')
			      (and 
				 (lessthan u' u)
				 (is-lawful-process m' p1 p2 p t pp u)
				 (made-reasonable-effort-to-notify p1 p2 p t pp u)))))
		     (<POL/512/f> 
			or
			(<POL/512/f1>  
			   and
			   (inrole p1 covered-entity u)
			   (belongrole p2 law-enforcement-official u)
			   (purp_in pp law-enforcement)
			   (or  %%different from Henry's, not clear how to interpret except laws subject to b1ii, c1i			   
			      (required-by-law p1 p2 p t pp u)
			      (in-compliance-with-court-order p1 p2 p t pp u)
			      (in-compliance-with-grand-jury-subpoena p1 p2 p t pp u)
			      (and
				 (in-compliance-with-admin-request p1 p2 p t pp u)
				 (minimum-necessary p1 p2 m pp u)
				 (deidentied-info-not-sufficient pp u))))
			(<POL/512/f2>  
			   and
			   (inrole p1 covered-entity u) 
			   (belongrole p2 law-enforcement-official u)
			   (attr_in t info-164-512-f2i)
			   (purp_in pp (law-enforcement-relevant-id-or-location p))
			   (ex[m'][u'] (send p2 p1 m' u')
			      (and 
				 (lessthan u' u)
				 (is-request-for m' p1 p2 p t pp u))))
			(<POL/512/f3> 
			   and
			   (inrole p1 covered-entity u)
			   (belongrole p2 law-enforcement-official u)
			   (or
			      (belongrole p victim-of-crime u)
			      (belongrole p suspected-victim-of-crime u))
			   (purp_in pp law-enforcement) 
			   (or 
			      (and 
				 (ex[m'][u'] (send p2 p1 m' u')
				    (and 
				       (lessthan u' u)
				       (is-request-for m' p1 p2 p t pp u)))
				 (ex[m''][u''] (send p p1 m'' u'')
				    (and 
				       (lessthan u'' u) 
				       (is-agreement-to m'' p1 p2 p t pp u))))
			      (and 
				 (ex[m1][u1] (send p2 p1 m1 u1)
				    (and 
				       (lessthan u1 u)
				       (is-request-for m1 p1 p2 p t pp u))) 
				 (is-emergency p u)
				 (represents-needed-to-determine-crime p2 p1 p2 p t pp u)
				 (represents-not-used-against-victim p2 p1 p2 p t pp u)
				 (represents-activity-adversely-affected-by-waiting p2 p1 p2 p t pp u)
				 (believes-in-best-interest p1 p1 p2 p t pp u))))
			(<POL/512/f4> 
			   and 
			   (inrole p1 covered-entity u)
			   (belongrole p2 law-enforcement-official u)
			   (deceased p u)
			   (purp_in pp (suspicious-death-notification p))
			   (believes-death-may-be-result-of-crime p1 p u))
			(<POL/512/f5> 
			   and
			   (inrole p1 covered-entity u)
			   (belongrole p2 law-enforcement-official u)
			   (purp_in pp (report-possible-crime-on-premises p1))
			   (believes-evidence-of-crime-on-premises p1 p t u))
			(<POL/512/f6> 
			   and 
			   (inrole p1 Health-care-provider u)
			   (belongrole p2 law-enforcement-official u)
			   (purp_in pp alert-of-crime-commission-location-victims-perpetrator)
			   (providing-emergency-healthcare p1 p u)
			   (appears-necessary-to-alert-of-crime-commission-location-victims-perpetrator p1 p2 p t pp u)
			   (not-believes-emergency-result-of-abuse-neglect-domestic-violence p1 p u)))))  
	       (<POL/512/b1>
		  and
		  (attr_in t phi)
		  (inrole p1 covered-entity u)
		  (or
		     (<POL/512/b1i> 
			and
			(or
			   (and %% different from Henry to pass mode check
			      (belongrole p2 public-health-authority u)
			      (is-authorized-by-law p2 pp u))
			   (and
			      (belongrole p2 foreign-gov-agency u)
			      (ex [p'] (directed-disclosure p' p1 p2 p t pp u)
				 (and 
				    (belongrole p' public-health-authority u)
				    (is-authorized-by-law p' pp u))))) 
			(or
			   (purp_in pp disease-prevention-control) 
			   (purp_in pp public-health-surveillance)
			   (purp_in pp public-health-investigation)
			   (purp_in pp public-health-intervention))) 
		     (<POL/512/b1ii> 
			and
			(or
			   (belongrole p2 public-health-authority u)
			   (belongrole p2 gov-authority u))
			(is-authorized-by-law p2 pp u)
			(purp_in pp reports-of-child-abuse))
		     (<POL/512/b1iii> 
			ex[pd] (FDA-regulated pd u)
			(and
			   (inrole p2 (responsible-for-product pd) u)
			   (purp_in pp (quality-safety-effectiveness-activities pd))))
		     (<POL/512/b1iv> 
			and
			(is-at-risk-of-contracting-or-spreading-disease p2 u)
			(purp_in pp notify-for-public-health-intervention))
		     (<POL/512/b1v> 
			and 
			(inrole p1 Health-care-provider u)
			(or
			   (is-workforce-member p1 p2 u)
			   (provides-medical-surveillance p2 p1 u)
			   (provides-medical-injury-evaluation p2 p1 u))
			(inrole p2 employer u)
			(is-workforce-member p p2 u)
			(or
			   (and 
			      (attr_in t workplace-injury-findings)
			      (purp_in pp obligation-to-record-workplace-injury))
			   (and
			      (attr_in t medical-surveillance-findings)
			      (purp_in pp obligation-to-perform-medical-surveillance )))
			(ex [m'][u'] (send p1 p m' u')
			   (is-notice-of-workplace-disclosure m' u)))))
	       (<POL/512/d> 
		  and
		  (inrole p1 covered-entity u)
		  (belongrole p2 health-oversight-agency u)
		  (is-authorized-by-law p2 pp u) 
		  (attr_in t phi)
		  (or %% different from Henry's mode checking will not work otherwise
		     (purp_in pp over-sight-government-benefit-programs-health-eligibility)
		     (purp_in pp over-sight-government-regulated-entity-health-compliance)
		     (purp_in pp over-sight-subject-to-civil-rights-health-compliance))
		  (and %% this is also different from Henry's
		     (is-not-subject-of-investigation p pp u) %% need to check this
		     (or
			(related-to-receipt-health-care pp u)
			(related-to-public-health-benefits pp u)
			(related-to-public-benefits-qualification-depends-on-health pp u))))
	       (<POL/512/g/1> 
		  and
		  (inrole p1 covered-entity u)
		  (or 
		     (inrole p2 coroner u)
		     (inrole p2 medical-examiner u))
		  (or
		     (purp_in pp (id p))
		     (purp_in pp (determine-cause-of-death p))
		     (authorized-by-law p2 pp u)))
	       (<POL/512/g/2> 
		  and
		  (inrole p1 covered-entity u)
		  (inrole p2 funeral-director u)
		  (attr_in t phi)
		  (purp_in pp (funeral-directory-duties p))
		  (necessary-for-duties p1 p2 p t pp u) 
		  (or
		     (deceased p u)
		     (ex[u'] (and (deceased p u') (time_in u' u (plus u t_reasonable)))
			(early-disclosure-necessary p1 p2 p t pp u))))
	       (<POL/512/h> 
		  and
		  (inrole p1 covered-entity u)
		  (or
		     (inrole p2 organ-procurement-organization u)
		     (inrole p2 engaged-in-procurement-banking-transplantation-of-organs-eyes-tissue u))
		  (attr_in t phi)
		  (purp_in pp facilitate-organ-eye-tissue-donation-transplantation))
	       (<POL/512/i1>  % abbreviate i2
		  and
		  (inrole p1 covered-entity u)
		  (inrole p2 researcher u)
		  (deceased p u)
		  (attr_in t phi)
		  (purp_in pp research)
		  (ex [p3][m'][u'] (send p3 p1 m' u')
		     (and
			(or
			   (inrole p3 (institutional-review-board p1) u)
			   (inrole p3 (privacy-board p1 p2 p t pp) u))
			(is-approval-of-authorization-waiver m' p3 p1 p1 p t pp u)))
		  (represents-disclosure-solely-for-research-preparation p2 p1 p2 p t pp u)
		  (represents-no-information-removed-during-review p2 p1 p2 p t pp u)
		  (represents-information-necessary-for-research p2 p1 p2 p t pp u)
		  (represents-disclosure-solely-for-decedent-research p2 p1 p2 p t pp u)
		  (represents-disclosure-necessary-for-research p2 p1 p2 p t pp u))
	       (<POL/512/j/1> 
		  or 
		  (<POL/512/j/1/i> 
		     and
		     (inrole p1 covered-entity u)
		     (purp_in pp lessen-health-threat)
		     (consistent-with-applicable-law p1 p2 p t pp u)
		     (believes-necessary-to-lessen-health-threat p1 p2 p t pp u)
		     (believes-can-lessen-threat p1 p2 pp u))
		  (and
		     (<POL/512/j/1/ii/A> 
			and
			(inrole p1 covered-entity u)
			(belongrole p2 law-enforcement-official u)
			(attr_in t phi)
			(purp_in pp (id-apprehend p))
			(consistent-with-applicable-law p1 p2 p t pp u)
			(ex [m'][u'] (send p p1 m' u')
			   (and 
			      (is-admission-of-crime m' p u)
			      (believes-crime-caused-serious-harm p1 m' u))))
		     (<POL/512/j/2/i> not-learned-while-treating-propensity-for-crime p1 p t u)
		     (<POL/512/j/2/ii> not-learned-through-request-for-treatment-of-propensity-for-crime p1 p t u) 
		     (<POL/512/j/3> %% typo in Henry's encoding, should be an and, not or
			attr_in t info-164-512-f2i))
		  (<POL/512/j/1/ii/B> 
		     and
		     (inrole p1 covered-entity u)
		     (belongrole p2 law-enforcement-official u)
		     (attr_in t phi)
		     (purp_in pp (id-apprehend p)) 
		     (consistent-with-applicable-law p1 p2 p t pp u)
		     (believes-escaped-lawful-custody p1 p u)))
	       (<POL/512/k/1/i> 
		  and 
		  (inrole p1 covered-entity u)
		  (belongrole p armed-forces-personnel u)
		  (attr_in t phi)
		  (ex[p3] (deemed-necessary-for-mission p3 p1 p2 p t pp u) % this has to be DB for mode checking
		     (and 
			(published-in-FR-command-authority-for-disclosure p3 p1 p2 p t pp u)
			(published-in-FR-purpose-for-disclosure p1 p2 p t pp u))))
	       (<POL/512/k/1/ii> 
		  and
		  (inrole p1 covered-entity u)
		  (belongrole p2 component-of-DoD-or-DoT u)
		  (inrole p2 DVA u)
		  (was-armed-forces-memeber p u) %% should this be subjective? may affect mode checking
		  (attr_in t phi)
		  (purp_in pp eligibility-determination-for-veterans-benefits))
	       (<POL/512/k/1/iii> 
		  and
		  (inrole p1 covered-entity u)
		  (inrole p1 component-of-DVA u)
		  (inrole p2 component-of-DVA u)
		  (attr_in t phi)
		  (or
		     (purp_in pp eligibility-determination-for-veterans-benefits)
		     (purp_in pp  provision-of-veterans-benefits)))
	       (<POL/512/k/1/iv> 
		  and
		  (inrole p1 covered-entity u)
		  (belongrole p2 foreign-military-personnel u)
		  (attr_in t phi)
		  (ex[p3] (deemed-necessary-for-mission p3 p1 p2 p t pp u) % this has to be DB for mode checking
		     (and 
			(published-in-FR-command-authority-for-disclosure p3 p1 p2 p t pp u)
			(published-in-FR-purpose-for-disclosure p1 p2 p t pp u))))
	       (<POL/512/k/2>
		  and
		  (inrole p1 covered-entity u)
		  (attr_in t phi)
		  (purp_in pp national-security-activities)
		  (NSA-authorized-recipient p2 u)
		  (NSA-authorized-purpose pp u))
	       (<POL/512/k/3> 
		  and 
		  (inrole p1 covered-entity u)
		  (attr_in t phi)
		  (belongrole p2 authorized-fed-official u)
		  (or
		     (and  %% different from Henry because of mode check
			(purp_in pp provision-of-protective-services)
			(or 
			   (authorized-to-receive-protection-18USC3056 pp u)
			   (authorized-to-receive-protection-22USC2709a3 pp u)))
		     (purp_in pp  conduct-investigations-18USC871-and-879))) 
	       (<POL/512/k/4> 
		  and 
		  (inrole p1 covered-entity u)
		  (inrole p1 component-of-DoS u)
		  (inrole p2 DoS-official u)
		  (attr_in t medical-suitability) % Henry might have a typo
		  (or
		     (purp_in pp security-clearance-EO-10450-and-12698)
		     (purp_in pp determine-availability-for-foreign-service-FSA-101a4-and-504 )
		     (purp_in pp determine-family-accompaniment-FSA-101b5-and-904 ))) 
	       (<POL/512/k/5/i> 
		  and 
		  (inrole p1 covered-entity u)
		  (or
		     (belongrole p2 correctional-institution u)
		     (belongrole p2 law-enforcement-official u))
		  (in-lawful-custody p p2 u)
		  (attr_in t phi)
		  (represents-necessary-for-providing-healthcare p2 t u) 
		  (represents-necessary-for-health-safety-of-inmates p2 t u)
		  (represents-necessary-for-health-safety-of-employees p2 t u)  
		  (represents-necessary-for-health-safety-of-transportation-officers p2 t u)
		  (represents-necessary-for-law-enforcement-on-premises p2 t u)
		  (represents-necessary-for-safety-security-order p2 t u))
	       (<POL/512/k/6/i> 
		  and
		  (inrole p1 health-plan u)
		  (inrole p1 government-public-benefits-program u)
		  (inrole p2 government-public-benefits-program u)
		  (attr_in t phi) 
		  (relates-to-eligibility-enrollment-in-health-plan t p p1 u)
		  (disclosure-required-or-authorized-by-statute-or-regulation p1 p2 p t pp u))
	       (<POL/512/k/6/ii> 
		  and
		  (inrole p1 covered-entity u)
		  (inrole p2 covered-entity u)
		  (attr_in t phi)
		  (ex[p3](is-government-agency-administering p1 p3 u)%% have to make it DB for mode check
		     (ex[p4] (is-government-agency-administering p2 p4 u)
			(and 
			   (belongrole p3 government-public-benefits-program u)
			   (belongrole p4 government-public-benefits-program u)
			   (relates-to-program p t p3 u)
			(serve-similar-populations p3 p4 u)
			   (or 
			      (necessary-for-coordination t p3 p4 u)
			      (necessary-for-improve-management t p3 p4 u))))))
	       (<POL/512/l> 
		  and
		  (inrole p1 covered-entity u)
		  (attr_in t phi)
		  (authorized-and-necessary-for-workers-compensation-laws p1 p2 p t pp u))
	       (<POL/514/e1> 
		  and
		  (inrole p1 covered-entity u)
		  (<POL/514/e2> 
		     and
		     (attr_in t phi)  %% change the mode for attr_in
		     (all[t'](and (sub_attr t' t) (attr_in t' postal-addr))
			(attr_in t' city-state-zipcode))
		     (imp 
			(or
			   (attr_in name t)
			   (attr_in telephone-number t)
			   (attr_in fax-number t)
			   (attr_in email-addr t)
			   (attr_in ssn t)
			   (attr_in medical-record-number t)
			   (attr_in health-plan-beneficiary-number t)
			   (attr_in account-numbers t)
			   (attr_in license-numbers t)
			   (attr_in vehicle-id t)
			   (attr_in device-id t)
			   (attr_in URLs t)
			   (attr_in ip-addr t)
			   (attr_in biometric-id t)
			   (attr_in full-face-image t)) 
			false))
		  (<POL/514/e3> 
		     or
		     (purp_in pp research)
		     (purp_in pp public-health)
		     (purp_in pp Healthcare-op))
		  (ex[m'][u'](send p2 p1 m' u')  %% 514/e/4
		     (and
			(lessthan u' u)
			(is-limited-data-use-agreement m' u')
			(contains-permitted-uses-disclosures m' p1 p2 u)
			(contains-permitted-recipients m' p1 p2 u)
			(contains-agreement-to-no-further-disclosures m' p1 p2 u)
			(contains-agreement-to-safeguards m' p1 p2 u)
			(contains-agreement-to-report-further-disclosures m' p1 p2 u) 
			(contains-agreement-to-subcontractor-agreements m' p1 p2 u)
			(contains-agreement-to-no-contact-or-identification m' p u) %% difference from Henry's
			)))
	       (and 
		  (<POL/514/f1> 
		     and 
		     (inrole p1 covered-entity u)
		     (or
			(inrole p2 (business-assoc p1) u)
			(inrole p2 (related-foundations p1) u))
		     (or
			(attr_in t demographic-info) 
			(attr_in t healthcare-dates))
		     (purp_in pp fundraising))
		  (<POL/514/f2> 
		     ex[m'][u'] (send p1 p2 m' u')
		     (and
			(lessthan u' u)
			(is-notice-164-520-biiiB m' p1 p2 p t pp u)
			(contains-statement-of-possible-fundraising m' p1 p2 u)
			(contains-opt-out-instructions m' p1 p2 u)))) %% different from Henry's, should be conj with f2
	       (<POL/508/a/3/i> %% shouldn't be negative form, because it won't allow marketing at all
		  and
		  (attr_in t phi)
		  (inrole p1 covered-entity u)
		  (purp_in pp marketing)
		  (or
		     (ex [m'][u'] (send p p1 m' u')
			(and
			   (lessthan u' u)
			   (is-valid-authorization-508 m' p1 p2 p t pp u)))
		     (and
			(eq_prin p2 p)
			(face-to-face-comm p1 p2 p pp u))
		     (promotional-gift-of-nominal-val p1 p2 p pp u)))
	       )%% end positive norms
	    ( %% negative norms
	       and
 	       (<POL/502/b>
  		  or 
  		  (<POL/502/b/1> 
  		     and
  		     (inrole p1 covered-entity u)
		     (believes-minimum-necessary-for-purpose p1 p2 p t pp u)
  		     (attr_in t phi))
  		  (<POL/502/b/2/i> 
  		     and
  		     (inrole p2 Health-care-provider u)
  		     (purp_in pp Treatment))
  		  (<POL/502/b/2/ii> %% 502/a/1/i 
  		     and
  		     (inrole p1 covered-entity u)
  		     (or
  			(eq_prin p2 p)
  			(inrole p2 (personal-rep p) u)))
  		  (<POL/502/b/2/iii> %% 502/a/1/iv 
  		     and
  		     (inrole p1 covered-entity u)
  		     (ex [m'][u'] (send p p1 m' u')
  			(and
  			   (lessthan u' u)
  			   (is-valid-authorization-508 m' p1 p2 p t pp u))))
  		  (<POL/502/b/2/iv> %% 502/a/2/ii 
  		     and
   		     (inrole p1 covered-entity u)
   		     (inrole p2 secretary u)
   		     (purp_in pp (compliance-investigation p1)))
  		  (<POL/502/b/2/v> %% 512/a 
  		     and
  		     (attr_in t phi) 
  		     (inrole p1 covered-entity u)
  		     (is-required-by-law p1 p2 p t pp u)
  		     ( or %% other negative forms
  			(<POL/512/c> 
  			   and
  			   (<POL/512/c1> 
  			      and
  			      (inrole p1 covered-entity u)
  			      (belongrole p2 goverment-authority u)
  			      (authorized-by-law-to-receive p2 pp u) 
  			      (believes-victim-of-abuse p1 p u)
  			      (purp_in pp reports-of-abuse) 
  			      (or 
  				 (is-requred-by-law p1 p2 p t pp u)
  				 (individual-has-agreed p1 p2 p t pp u)
  				 (and 
  				    (authorized-by-statue-regulation p1 p2 p t pp u)
  				    (or 
  				       (believes-disclosure-necessary-to-prevent-harm p1 p2 p t pp u)
  				       (and
  					  (incapacitated p)
  					  (assurance-disclosure-not-used-against-individual p1 p2 p t pp u)
  					  (believes-waiting-for-agreement-would-hinder-enforcement p1 p2 p t pp u))))))
  			   (or 
  			      (<POL/512/c2> 
  				 ex[m'][u'] (send p1 p m' u')
  				 (and 
  				    (is-notice-of-report m' p1 p2 p t pp u)
  				    (or
  				       (lessthan u u')
  				       (lessthan u' (plus u  prompt)))))
  			      (<POL/512/c2/i> 
  				 believes-notice-would-risk-indivdual p1 p2 p t pp u)
  			      (<POL/512/c2/ii>%% different from Henry's encoding
  				 or 
  				 (and 
  				    (would-inform-pr p1 p2 p t pp u)
  				    (believes-pr-responsible p1 p u)) 
  				 (believes-informing-is-not-in-the-best-interest p1 p2 p t pp u)))) 
  			(<POL/512/e> 
  			   or
  			   (<POL/512/e/1/i>  
  			      and 
  			      (inrole p1 covered-entity u)
  			      (purp_in pp judicial-admin-proceeding) 
  			      (or 
  				 (authorized-by-court-order p1 p2 p t pp u)
  				 (authorized-by-tribunal-order p1 p2 p t pp u)))
  			%% different from Henry's encoding. don't think we need to treat court as a role
  			   (<POL/512/e/1/ii> 
  			      and 
  			      (inrole p1 covered-entity u)
  			      (purp_in pp judicial-admin-proceeding)
  			      (ex[m'][u'] (send p2 p1 m' u')
  				 (and 
  				    (lessthan u' u)
  				    (is-lawful-process m' p1 p2 p t pp u)
  				 %% could expand definition
  				    (received-satisfactory-assurance-164/512e1iii p1 p2 p t pp u)
  				    (received-satisfactory-assurance-164/512e1iv p1 p2 p t pp u))))
  			   (<POL/512/e/i/vi> 
  			      and 
  			      (inrole p1 covered-entity u) 
  			      (purp_in pp judicial-admin-proceeding)
  			      (ex[m'][u'] (send p2 p1 m' u')
  				 (and 
  				    (lessthan u' u)
  				    (is-lawful-process m' p1 p2 p t pp u)
  				    (made-reasonable-effort-to-notify p1 p2 p t pp u)))))
  			(<POL/512/f> 
  			   or
  			   (<POL/512/f1>  
  			      and
  			      (inrole p1 covered-entity u)
  			      (belongrole p2 law-enforcement-official u)
  			      (purp_in pp law-enforcement)
  			      (or  %%different from Henry's, not clear how to interpret except laws subject to b1ii, c1i			   
  				 (required-by-law p1 p2 p t pp u)
  				 (in-compliance-with-court-order p1 p2 p t pp u)
  				 (in-compliance-with-grand-jury-subpoena p1 p2 p t pp u)
  				 (and
  				    (in-compliance-with-admin-request p1 p2 p t pp u)
  				    (minimum-necessary p1 p2 m pp u)
  				    (deidentied-info-not-sufficient pp u))))
  			   (<POL/512/f2>  
  			      and
  			      (inrole p1 covered-entity u) 
  			      (belongrole p2 law-enforcement-official u)
  			      (attr_in t info-164-512-f2i)
  			      (purp_in pp (law-enforcement-relevant-id-or-location p))
  			      (ex[m'][u'] (send p2 p1 m' u')
  				 (and 
  				    (lessthan u' u)
  				    (is-request-for m' p1 p2 p t pp u))))
  			   (<POL/512/f3> 
  			      and
  			      (inrole p1 covered-entity u)
  			      (belongrole p2 law-enforcement-official u)
  			      (or
  				 (belongrole p victim-of-crime u)
  				 (belongrole p suspected-victim-of-crime u))
  			      (purp_in pp law-enforcement) 
  			      (or 
  				 (and 
  				    (ex[m'][u'] (send p2 p1 m' u')
  				       (and 
  					  (lessthan u' u)
  					  (is-request-for m' p1 p2 p t pp u)))
  				    (ex[m''][u''] (send p p1 m'' u'')
  				       (and 
  					  (lessthan u'' u) 
  					  (is-agreement-to m'' p1 p2 p t pp u))))
  				 (and 
  				    (ex[m1][u1] (send p2 p1 m1 u1)
  				       (and 
  					  (lessthan u1 u)
  					  (is-request-for m1 p1 p2 p t pp u))) 
  				    (is-emergency p u)
  				    (represents-needed-to-determine-crime p2 p1 p2 p t pp u)
  				    (represents-not-used-against-victim p2 p1 p2 p t pp u)
  				    (represents-activity-adversely-affected-by-waiting p2 p1 p2 p t pp u)
  				    (believes-in-best-interest p1 p1 p2 p t pp u))))
  			   (<POL/512/f4> 
  			      and 
  			      (inrole p1 covered-entity u)
  			      (belongrole p2 law-enforcement-official u)
  			      (deceased p u)
  			      (purp_in pp (suspicious-death-notification p))
  			      (believes-death-may-be-result-of-crime p1 p u))
  			   (<POL/512/f5> 
  			      and
  			      (inrole p1 covered-entity u)
  			      (belongrole p2 law-enforcement-official u)
  			      (purp_in pp (report-possible-crime-on-premises p1))
  			      (believes-evidence-of-crime-on-premises p1 p t u))
  			   (<POL/512/f6> 
  			      and 
  			      (inrole p1 Health-care-provider u)
  			      (belongrole p2 law-enforcement-official u)
  			      (purp_in pp alert-of-crime-commission-location-victims-perpetrator)
  			      (providing-emergency-healthcare p1 p u)
  			      (appears-necessary-to-alert-of-crime-commission-location-victims-perpetrator p1 p2 p t pp u)
  			      (not-believes-emergency-result-of-abuse-neglect-domestic-violence p1 p u))))))
 	       (<POL/502/g/3/ii/B>
 		  imp
 		  (and
 		     (inrole p1 covered-entity u)
 		     (or
 			(inrole p2 (parent p) u) 
 			(inrole p2 (guardian p) u) 
 			(inrole p2 (in-loco-parentis p) u)) 
 		     (attr_in t phi)) 
 		  (not-prohibited-by-other-laws p1 p2 p t pp u))
  	       (<POL/508/a/2> 	     
  		  or
  		  (imp
  		     (and %% 508a2 
  			(attr_in t psychotherapy-notes)
  			(inrole p1 covered-entity u))
  		     (ex [m'][u'] (send p p1 m' u')
  			(and
   		       (lessthan u' u)
  			   (is-valid-authorization-508 m' p1 p2 p t pp u))))
  		  (and %% 508a2iB
  		     (inrole p1 covered-entity u)
  		     (purp_in pp (counseling-training-programs p1)))
  		  (and %% 508a2iC
  		     (inrole p1 covered-entity u)
  		     (purp_in pp (defense-in-legal-proceeding p1 p)))
 		  (<POL/508/a/2/ii> 
 		     or 
 		     (<POL/502/a/2/ii> 
 			and
 			(inrole p1 covered-entity u)
 			(inrole p2 secretary u)
 			(purp_in pp (compliance-investigation p1)))
 		     (<POL/512/a'> 
 			and
 			(attr_in t phi) 
 			(inrole p1 covered-entity u)
 			(is-required-by-law p1 p2 p t pp u)
 			( or %% other negative forms
 			   (<POL/512/c> 
 			      and
 			      (<POL/512/c1> 
 				 and
 				 (inrole p1 covered-entity u)
 				 (belongrole p2 goverment-authority u)
 				 (authorized-by-law-to-receive p2 pp u) 
 				 (believes-victim-of-abuse p1 p u)
 				 (purp_in pp reports-of-abuse) 
 				 (or 
 				    (is-requred-by-law p1 p2 p t pp u)
 				    (individual-has-agreed p1 p2 p t pp u)
 				    (and 
 				       (authorized-by-statue-regulation p1 p2 p t pp u)
 				       (or 
 					  (believes-disclosure-necessary-to-prevent-harm p1 p2 p t pp u)
 					  (and
 					     (incapacitated p)
 					     (assurance-disclosure-not-used-against-individual p1 p2 p t pp u)
 					     (believes-waiting-for-agreement-would-hinder-enforcement p1 p2 p t pp u))))))
 			      (or 
 				 (<POL/512/c2> 
 				    ex[m'][u'] (send p1 p m' u')
 				    (and 
 				       (is-notice-of-report m' p1 p2 p t pp u)
 				       (or
 					  (lessthan u u')
 					  (lessthan u' (plus u  prompt)))))
 				 (<POL/512/c2/i> 
 				    believes-notice-would-risk-indivdual p1 p2 p t pp u)
 				 (<POL/512/c2/ii>%% different from Henry's encoding
 				    or 
   			(and 
   			   (would-inform-pr p1 p2 p t pp u)
   			   (believes-pr-responsible p1 p u)) 
 				    (believes-informing-is-not-in-the-best-interest p1 p2 p t pp u)))) 
 			   (<POL/512/e> 
 			      or
 			      (<POL/512/e/1/i>  
 				 and 
 				 (inrole p1 covered-entity u)
 				 (purp_in pp judicial-admin-proceeding) 
 				 (or 
 				    (authorized-by-court-order p1 p2 p t pp u)
 				    (authorized-by-tribunal-order p1 p2 p t pp u)))
 			   %% different from Henry's encoding. don't think we need to treat court as a role
 			      (<POL/512/e/1/ii> 
 				 and 
 				 (inrole p1 covered-entity u)
 				 (purp_in pp judicial-admin-proceeding)
 				 (ex[m'][u'] (send p2 p1 m' u')
 				    (and 
 				       (lessthan u' u)
 				       (is-lawful-process m' p1 p2 p t pp u)
 				    %% could expand definition
 				       (received-satisfactory-assurance-164/512e1iii p1 p2 p t pp u)
 				       (received-satisfactory-assurance-164/512e1iv p1 p2 p t pp u))))
 			      (<POL/512/e/i/vi> 
 				 and 
 				 (inrole p1 covered-entity u) 
 				 (purp_in pp judicial-admin-proceeding)
 				 (ex[m'][u'] (send p2 p1 m' u')
 				    (and 
				       (lessthan u' u)
 				       (is-lawful-process m' p1 p2 p t pp u)
 				       (made-reasonable-effort-to-notify p1 p2 p t pp u)))))
 			   (<POL/512/f> 
 			      or
 			      (<POL/512/f1>  
 				 and
 				 (inrole p1 covered-entity u)
 				 (belongrole p2 law-enforcement-official u)
 				 (purp_in pp law-enforcement)
 				 (or  %%different from Henry's, not clear how to interpret except laws subject to b1ii, c1i			   
 				    (required-by-law p1 p2 p t pp u)
 				    (in-compliance-with-court-order p1 p2 p t pp u)
 				    (in-compliance-with-grand-jury-subpoena p1 p2 p t pp u)
 				    (and
 				       (in-compliance-with-admin-request p1 p2 p t pp u)
 				       (minimum-necessary p1 p2 m pp u)
 				       (deidentied-info-not-sufficient pp u))))
 			      (<POL/512/f2>  
 				 and
 				 (inrole p1 covered-entity u) 
 				 (belongrole p2 law-enforcement-official u)
 				 (attr_in t info-164-512-f2i)
 				 (purp_in pp (law-enforcement-relevant-id-or-location p))
 				 (ex[m'][u'] (send p2 p1 m' u')
 				    (and 
 				       (lessthan u' u)
 				       (is-request-for m' p1 p2 p t pp u))))
 			      (<POL/512/f3> 
 				 and
 				 (inrole p1 covered-entity u)
 				 (belongrole p2 law-enforcement-official u)
 				 (or
 				    (belongrole p victim-of-crime u)
 				    (belongrole p suspected-victim-of-crime u))
 				 (purp_in pp law-enforcement) 
 				 (or 
 				    (and 
 				       (ex[m'][u'] (send p2 p1 m' u')
 					  (and 
 					     (lessthan u' u)
 					     (is-request-for m' p1 p2 p t pp u)))
 				       (ex[m''][u''] (send p p1 m'' u'')
 					  (and 
 					     (lessthan u'' u) 
 					     (is-agreement-to m'' p1 p2 p t pp u))))
 				    (and 
 				       (ex[m1][u1] (send p2 p1 m1 u1)
 					  (and 
 					     (lessthan u1 u)
 					     (is-request-for m1 p1 p2 p t pp u))) 
 				       (is-emergency p u)
 				       (represents-needed-to-determine-crime p2 p1 p2 p t pp u)
 				       (represents-not-used-against-victim p2 p1 p2 p t pp u)
 				       (represents-activity-adversely-affected-by-waiting p2 p1 p2 p t pp u)
 				       (believes-in-best-interest p1 p1 p2 p t pp u))))
 			      (<POL/512/f4> 
 				 and 
 				 (inrole p1 covered-entity u)
 				 (belongrole p2 law-enforcement-official u)
 				 (deceased p u)
 				 (purp_in pp (suspicious-death-notification p))
 				 (believes-death-may-be-result-of-crime p1 p u))
 			      (<POL/512/f5> 
 				 and
 				 (inrole p1 covered-entity u)
 				 (belongrole p2 law-enforcement-official u)
 				 (purp_in pp (report-possible-crime-on-premises p1))
 				 (believes-evidence-of-crime-on-premises p1 p t u))
 			      (<POL/512/f6> 
 				 and 
 				 (inrole p1 Health-care-provider u)
 				 (belongrole p2 law-enforcement-official u)
 				 (purp_in pp alert-of-crime-commission-location-victims-perpetrator)
 				 (providing-emergency-healthcare p1 p u)
 				 (appears-necessary-to-alert-of-crime-commission-location-victims-perpetrator p1 p2 p t pp u)
 				 (not-believes-emergency-result-of-abuse-neglect-domestic-violence p1 p u))))) %% end of 512a'
 		     (<POL/512/d> %% an abbreviated version
 			and 
 			(inrole p1 covered-entity u)
 			(belongrole p2 health-oversight-agency u)
 			(purp_in pp Oversight))
 		     (<POL/512/g/1> 
 			and
 			(inrole p1 covered-entity u)
			(or 
			   (inrole p2 coroner u)
			   (inrole p2 medical-examiner u))
 			(or
 			   (purp_in pp (id p))
 			   (purp_in pp (determine-cause-of-death p))
 			   (authorized-by-law p2 pp u)))
 		     (<POL/512/j/1/i> 
 			and 
 			(inrole p1 covered-entity u)
 			(purp_in pp lessen-health-threat)
 			(consistent-with-applicable-law p1 p2 p t pp u)
 			(believes-necessary-to-lessen-health-threat p1 p2 p t pp u)
 			(believes-can-lessen-threat p1 p2 pp u))))
	       (<POL/514/g> %% different from Henry's to make guard work
		  all [p'][u3][m'] 
		  (and
		     (send p' p1 m' u3)
		     (lessthan u3 u)
		     (inrole p1 health-plan u))
		  (all [i'][pp']  (and (eq_msg m' (msg i' pp'))  (hasattrof i' p t))
		     (or
			(and
			   (imp (purp_in pp' health-insurance-contact-creation) false)
			   (imp (purp_in pp' health-insurance-contact-renewal ) false)
			   (imp (purp_in pp' health-insurance-contact-replacement) false))
			(health-insurance-placed-with p' p1 u)
			(or
			   (purp_in pp health-insurance-contact-creation)
			   (purp_in pp health-insurance-contact-renewal)
			   (purp_in pp health-insurance-contact-replacement)
			   (required-by-law p1 p2 p t pp u)))))
	       )%% end negative norms
	    ))))
