/*

Copyright (c) <2010>, <Deepak Garg, garg.deepak@gmail.com>
Copyright (c) <2011>, <Limin Jia, liminjia@cmu.edu>
All rights reserved.

Use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

- Code derived from this source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

- Use or modification is not done for any commercial purpose or for
  monetary gain

Redistribution without permission of original copyright holder is
prohibited.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#ifndef __HIPAA_CONSTS_HPP
#define __HIPAA_CONSTS_HPP


//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////

// control whether to generate the subjective predicates or not
static const bool genSubjPred = false; 
// How long (in days) does the simulation run? (Simulation starts at
// time 0)

// static const int maxSimTime = 365*5; //20K disclosures
 static const int maxSimTime = 913; //10K disclosures
//static const int maxSimTime = 457; //5K disclosures

// How many records are active for each patient?
static const int nActiveRecords = 10;

// How many fixed people exist in the facility?
static const int nPatient = 1000;


// Mean spans of various events in days
static const int meanPatientRet = 365*10;
// mean value the hospital's retention of patients
static const int meanGapHospitalVisit = 120;
//mean gap of two hospital visits 
static const int meanGapOtherHospitalVisit = 365;
//mean gap of two visits to other health facilities
static const int meanGapDiscloseForNotification = 10; 
static const int meanGapDiscloseToAssistTP = 10; 
static const int meanGapLawReq = 10; 
static const int meanGapCourtOrder = 30; 
static const int meanGapConsent = 10; 
static const int meanGapMarketing = 120; 
static const int meanGapReportAbuse = 180; 
static const int meanGapToLaw = 30; 
static const int meanGapReportCrime = 365; 
static const int meanGapIdCriminal = 30; 
static const int meanGapApprehendEscaped = 180; 

//static const int meanHospitalStay = 5;
//mean number of days that a patient stay in a hospital
static const int prompt = 1;

static const int meanIncapabilityLength = 15; 
// Mean number days that a patient incapability lasts for
static const int meanIncapabilityGap = 365 * 4; 
// Mean number of days between two incapabilities for a single patient

static const int meanGapDisclose = 1;
// Mean number days between hospital releasing info and patient visit
static const int meanGapResponse = 1;
// Mean number days between hospital releasing info and law-enforcement request

// Probabilities of various sub-events

static const double discloseDueToOtherVisits = 1.1;
  // when the patient visit other health facilities, with this probability, the hospital need to disclose info to others

// parameters to tune violation rate: 1 -- no vioaltion, 0 -- all vioaltions
static const double inRole = 0.9;
static const double inRel = 0.9;
static const double participantOfOrganizedHealth = 0.9;
static const double purpIn = 0.9;
static const double obtainedConsent = 0.9;
static const double obtainedAuthorization = 0.9;
static const double admittedCrime= 0.9;
static const double attrIn512f2i = 0.9;
static const double obtainedAgreement = 0.9;
static const double hasAgreed= 0.9;
static const double sendNotice = 0.9;
static const double attrIn = 0.9;
static const double isWorkforceMem = 0.9;

// parameters to generate subjective predicates, for future use
static const double pertainToRel = 1;
static const double belongRole = 0.95;
static const double createDirInfo = 0.95;
static const double createPsychoNotes = 0.01;
//static const double injuryVisit = 0.01;
static const double deathVisit = 0.01;
static const double suspiciousDeath = 0.01;
static const double funeral = 0.95;
static const double informFamilyDeath = 0.95;
static const double informFamily = 0.01;
static const double examineDeath = 0.1;
static const double discloseForTPO = 0.95;
static const double criminalReport = 0.01;
static const double isValidAuth = 0.955;
static const double necessaryForDuties = 0.955;
static const double believesDeathMaybeResultOfCrime = 0.955;
static const double believesEvidenceOfCrimeOnPremises = 0.955;
static const double faceToFace = 0.95;
static const double promotionalGiftOfNominalVal = 0.95;
static const double believesEscapedLawfulCustody = 0.95;
static const double consistentWithLaw= 0.95;
static const double believesCrimeCausedHarm= 0.95;
static const double notLearnedWhileTreatingPropensityForCrime = 0.95;
static const double notLearnedThroughRequestForTreatingPropensityForCrime = 0.95;
static const double minimumNecessary = 0.95;
static const double deidentifiedInfoNotSufficient = 0.95;
static const double requiredByLaw = 0.95;
static const double inCompWithCourtOrder = 0.95;
static const double inCompWithJurySubpoena = 0.95;
static const double inCompWithAdminReq = 0.95;
static const double isRequest = 0.95;
static const double isAgreement = 0.95;
static const double isEmergency = 0.01;
static const double representsNeededToDetermineCrime = 0.95;
static const double representsNotUsedAgainstVictim= 0.95;
static const double representsActivityAdverselyAffectedByWaiting = 0.95;
static const double believesInBestInterest= 0.95;
static const double believesVictimOfAbuse= 0.95;
static const double authorizedByLawToRecv= 0.95;
static const double authorizedByLaw= 0.95;
static const double authorizedByStatuteOrRegulation= 0.95;
static const double believesDisclosureNecessaryToPreventHarm = 0.95;
static const double assuranceDisclosureNotUsedAgainstIndividual = 0.95;
static const double believesWaitingForAgreementWouldHinderEnforcement = 0.95;
static const double believesNoticeWouleRiskIndividual = 0.95;
static const double believesInformingIsNotInTheBestInterest = 0.95;
static const double wouldInformPr = 0.95;
static const double believesPrResponsible = 0.95;
static const double isNoticeOfReport = 0.95;
static const double authorizedByCourtOrder= 0.95;
static const double authorizedByTribunalOrder= 0.95;
static const double isLawfulProcess = 0.95;
static const double madeReasonableEffortToNotify = 0.95;
static const double receivedSatisfactoryAssurance512e1iii = 0.95;
static const double receivedSatisfactoryAssurance512e1iv = 0.95;
static const double relevantToInvolvement=0.95;
static const double inCapableToMakeHCDecisions = 0.95;
static const double CapableToMakeHCDecisions = 0.95;
static const double professionalJudgmentIsInBestInterestOf510b3 = 0.95;
static const double available = 0.95;
static const double notAvailable = 0.95;
static const double obtainedAgreement510b2 = 0.95;
static const double hasProvidedOppToObj510b2 = 0.95;
static const double professionalJudgmentIndividualDoesNotObject  = 0.95;


#endif
