#!/usr/bin/perl

# Copyright (c) <2011>, <Limin Jia, liminjia@cmu.edu>

# All rights reserved.

# Use in source and binary forms, with or without modification, are
# permitted provided that the following conditions are met:

# - Code derived from this source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.

# - Use or modification is not done for any commercial purpose or for
#   monetary gain

# Redistribution without permission of original copyright holder is
# prohibited.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

use POSIX ":sys_wait_h";

$peak = 0;
$counter = 0;
$tId = @ARGV[1];

$pid = fork();
if ($pid){

# parent polls peak mem usage

 do{
#   print "In parent\n";
   system ("ps -p $pid -o rss= >sampleFile");

   open ($fd, '<', "sampleFile") or die $!;
   my $sample = <$fd>;
   close ($fd);
   $sample =~ s/^\s+|\s+$//g;
   $counter = $counter +1;
   if ($sample > $peak) {$peak = $sample}
#   print "sample size is $sample";
   $status = waitpid($pid, &WNOHANG);
   sleep 0.01

 } until ($status > 0) ;
 system ("rm -f sampleFile");
 print "UPDATE res SET memFootprint = $peak WHERE testId = $tId; \n";
# print "number of samples is $counter\n";
}

else {
# child runs the program
exec @ARGV;
}
