(*

Copyright (c) <2011> <Deepak Garg dg@cs.cmu.edu>

All rights reserved.

Use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

- Code derived from this source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

- Use or modification is not done for any commercial purpose or for
  monetary gain

Redistribution without permission of original copyright holder is
prohibited.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*)

(*************************************************************************)

(*************************************************************************)

structure TestSQL = struct

structure SQLiteSQL = SQLFn (SQLiteDb)

val ds = Option.valOf (DeclParser.parse_decls_file "bogeholz.d")

val _ = Declaration.check_decls ds

val connection = Option.valOf (SQLiteSQL.Db.newConnection "bogeholz.db")

val p = "beginrole"

val tl = [Fol.tVar "x", Fol.tVar "y", Fol.tVar "z"]

val count = ref 0

fun cont (Solution.NOMORE) = ()
  | cont (Solution.NEXT tl) = 
    (count := (!count) + 1 ;
     print ((Fol.print_term_list tl) ^ "\n") )

val _  = SQLiteSQL.resolve_db_pred ds connection
				   p tl cont

val _ = SQLiteSQL.Db.closeConnection connection

val _ = print ("Total: " ^ (Int.toString (!count)) ^ "\n")


end
