# Copyright (c) <2011>, <Limin Jia, liminjia@cmu.edu>

# All rights reserved.

# Use in source and binary forms, with or without modification, are
# permitted provided that the following conditions are met:

# - Code derived from this source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.

# - Use or modification is not done for any commercial purpose or for
#   monetary gain

# Redistribution without permission of original copyright holder is
# prohibited.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

nMainTest=9
nItTest=3

rm -f results.db
sqlite3 results.db < ./DbPrepFiles/initResults


  for ((i = 1; i <= nMainTest; i++)) 
  do
      if [ $i -lt 6 ]; then
  	 cp ./hipaa-simulator/hipaa5K.db ./hipaa.db
	 echo "done cp hipaa5K exp $i"
  	 if [ $i -lt 5 ]; then
  	     sqlite3 hipaa.db < ./DbPrepFiles/prepHipaaDb$i
	     echo "done prep DB exp $i"
  	 else
  	     echo " "
  	 fi
      else 
  	 case $i in
  	     6)
		 cp ./hipaa-simulator/hipaa10K.db ./hipaa.db
		 echo "done cp hipaa10K exp $i" ;;
  	     7) 
		 cp ./hipaa-simulator/hipaa09.db ./hipaa.db
		 echo "done cp hipaa09 exp $i" ;;
  	     8)	
		 cp ./hipaa-simulator/hipaa1.db ./hipaa.db
		 echo "done cp hipaa1 exp $i" ;;
  	     9) 
		 cp ./hipaa-simulator/hipaa0.db ./hipaa.db
		 echo "done cp hipaa0 exp $i" ;;
  	 esac
      fi
       
      # sqlite3 results.db < ./DbPrepFiles/prepResDb$i

      echo "update res set dbSize = `ls -l hipaa.db |awk '{printf "%.2f", $5/(1024*1024)}'` where testId = $i;" > output
      sqlite3 results.db < output
      echo "done update db size experiment $i"
	    

      perl run-hipaa.pl ./test-hipaa $i > output
      echo "done reduce experiment $i"
	    
      sqlite3 results.db < output
      echo "done update result experiment $i"
	    
      rm -f output
      rm -f hipaa.db
  done

 for ((i = 1 + nMainTest; i <= nItTest + nMainTest; i++)) 
 do

     case $i in
	 10) cp ./hipaa-simulator/hipaa5K.db ./hipaa.db
	     echo "done cp hipaa5K exp $i" ;;
	 11) cp ./hipaa-simulator/hipaa10K.db ./hipaa.db
	     echo "done cp hipaa10K exp $i";;
	 12) cp ./hipaa-simulator/hipaa09.db ./hipaa.db
	     echo "done cp hipaa09 exp $i";;
     esac
               
     echo "update res set dbSize = `ls -l hipaa.db |awk '{printf "%.2f", $5/(1024*1024)}'` where testId = $i;" > output
     sqlite3 results.db < output
     echo "done update db size experiment $i"

     echo "update formsize set size = `ls -l ./hipaa-case-study/hipaa.f |awk '{printf "%.2f", $5/1024}'` where testId = $i;" > output
     sqlite3 results.db < output
     echo "done update form size experiment $i"
     
     perl run-hipaa.pl ./test-hipaa $i > output
     echo "done reduce experiment $i"

     sqlite3 results.db < output
     echo "done update result experiment $i"
     rm -f output
     rm -f hipaa.db
     cp rform rform$i
     mv rform ./hipaa-case-study/hipaa.f
 done

